/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     K_OPTIONS = 258,
     K_DEFAULT = 259,
     K_PORT = 260,
     K_BINDADDR = 261,
     K_PERSIST = 262,
     K_TIMEOUT = 263,
     K_PASSWD = 264,
     K_PROG = 265,
     K_PPP = 266,
     K_SPEED = 267,
     K_IFCFG = 268,
     K_FWALL = 269,
     K_ROUTE = 270,
     K_DEVICE = 271,
     K_MULTI = 272,
     K_SRCADDR = 273,
     K_IFACE = 274,
     K_ADDR = 275,
     K_TYPE = 276,
     K_PROT = 277,
     K_COMPRESS = 278,
     K_ENCRYPT = 279,
     K_KALIVE = 280,
     K_STAT = 281,
     K_UP = 282,
     K_DOWN = 283,
     K_SYSLOG = 284,
     K_IPROUTE = 285,
     K_HOST = 286,
     K_ERROR = 287,
     WORD = 288,
     PATH = 289,
     STRING = 290,
     NUM = 291,
     DNUM = 292
   };
#endif
#define K_OPTIONS 258
#define K_DEFAULT 259
#define K_PORT 260
#define K_BINDADDR 261
#define K_PERSIST 262
#define K_TIMEOUT 263
#define K_PASSWD 264
#define K_PROG 265
#define K_PPP 266
#define K_SPEED 267
#define K_IFCFG 268
#define K_FWALL 269
#define K_ROUTE 270
#define K_DEVICE 271
#define K_MULTI 272
#define K_SRCADDR 273
#define K_IFACE 274
#define K_ADDR 275
#define K_TYPE 276
#define K_PROT 277
#define K_COMPRESS 278
#define K_ENCRYPT 279
#define K_KALIVE 280
#define K_STAT 281
#define K_UP 282
#define K_DOWN 283
#define K_SYSLOG 284
#define K_IPROUTE 285
#define K_HOST 286
#define K_ERROR 287
#define WORD 288
#define PATH 289
#define STRING 290
#define NUM 291
#define DNUM 292




/* Copy the first part of user declarations.  */
#line 1 "cfg_file.y"

/*  
    VTun - Virtual Tunnel over TCP/IP network.

    Copyright (C) 1998-2000  Maxim Krasnyansky <max_mk@yahoo.com>

    VTun has been derived from VPPP package by Maxim Krasnyansky. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 */

/*
 * cfg_file.y,v 1.1.1.2.2.13.2.4 2006/11/16 04:02:42 mtbishop Exp
 */ 

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <syslog.h>

#include "compat.h"
#include "vtun.h"
#include "lib.h"

int lineno = 1;

struct vtun_host *parse_host;
extern struct vtun_host default_host;

llist  *parse_cmds;
struct vtun_cmd parse_cmd;

llist host_list;

int  cfg_error(const char *fmt, ...);
int  add_cmd(llist *cmds, char *prog, char *args, int flags);
void *cp_cmd(void *d, void *u);
int  free_cmd(void *d, void *u);

void copy_addr(struct vtun_host *to, struct vtun_host *from);
int  free_host(void *d, void *u);
void free_addr(struct vtun_host *h);
void free_host_list(void);

int  parse_syslog(char *facility);

int yyparse(void);
int yylex(void);	
int yyerror(char *s); 

#define YYERROR_VERBOSE 1



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 67 "cfg_file.y"
typedef union YYSTYPE {
   char *str;
   int  num;
   struct { int num1; int num2; } dnum;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 222 "cfg_file.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 234 "cfg_file.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   210

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  41
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  24
/* YYNRULES -- Number of rules. */
#define YYNRULES  87
/* YYNRULES -- Number of states. */
#define YYNSTATES  140

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   292

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      38,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    39,     2,    40,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    14,    15,    21,    22,
      28,    30,    32,    35,    37,    40,    45,    48,    51,    54,
      57,    60,    63,    66,    69,    72,    74,    77,    80,    83,
      85,    87,    89,    91,    93,    96,    98,   101,   104,   107,
     110,   113,   116,   117,   121,   124,   125,   129,   132,   135,
     138,   141,   146,   147,   153,   154,   160,   162,   164,   166,
     168,   170,   172,   174,   175,   177,   180,   183,   186,   189,
     192,   194,   195,   197,   200,   202,   203,   207,   210,   213,
     216,   219,   222,   224,   226,   229,   231,   233
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      42,     0,    -1,    -1,    42,    43,    -1,    38,    -1,     3,
      39,    46,    40,    -1,    -1,     4,    44,    39,    50,    40,
      -1,    -1,    31,    45,    39,    50,    40,    -1,    32,    -1,
      47,    -1,    46,    47,    -1,    38,    -1,     5,    36,    -1,
       6,    39,    48,    40,    -1,    19,    35,    -1,    21,    36,
      -1,     8,    36,    -1,    11,    34,    -1,    13,    34,    -1,
      15,    34,    -1,    14,    34,    -1,    30,    34,    -1,    29,
      49,    -1,    32,    -1,    20,    33,    -1,    19,    33,    -1,
      19,    35,    -1,    32,    -1,    36,    -1,    33,    -1,    32,
      -1,    51,    -1,    50,    51,    -1,    38,    -1,     9,    33,
      -1,    16,    33,    -1,    17,    36,    -1,     8,    36,    -1,
      12,    36,    -1,    12,    37,    -1,    -1,    23,    52,    56,
      -1,    24,    36,    -1,    -1,    25,    53,    57,    -1,    26,
      36,    -1,     7,    36,    -1,    21,    36,    -1,    22,    36,
      -1,    18,    39,    58,    40,    -1,    -1,    27,    54,    39,
      60,    40,    -1,    -1,    28,    55,    39,    60,    40,    -1,
      32,    -1,    36,    -1,    37,    -1,    32,    -1,    36,    -1,
      37,    -1,    32,    -1,    -1,    59,    -1,    58,    59,    -1,
      20,    33,    -1,    19,    33,    -1,    19,    35,    -1,     5,
      36,    -1,    32,    -1,    -1,    61,    -1,    60,    61,    -1,
      38,    -1,    -1,    10,    62,    63,    -1,    11,    35,    -1,
      13,    35,    -1,    15,    35,    -1,    14,    35,    -1,    30,
      35,    -1,    32,    -1,    64,    -1,    63,    64,    -1,    34,
      -1,    35,    -1,    36,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    86,    86,    87,    90,    91,    93,    93,    98,    98,
     131,   138,   139,   143,   144,   149,   151,   156,   161,   166,
     171,   176,   181,   186,   191,   193,   200,   205,   210,   215,
     222,   226,   233,   240,   241,   246,   247,   252,   257,   261,
     265,   273,   282,   282,   287,   295,   295,   300,   307,   314,
     319,   324,   326,   326,   331,   331,   336,   343,   350,   355,
     362,   367,   375,   381,   382,   383,   387,   393,   399,   405,
     409,   415,   416,   417,   420,   421,   421,   429,   434,   439,
     444,   449,   454,   461,   462,   466,   470,   474
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_OPTIONS", "K_DEFAULT", "K_PORT",
  "K_BINDADDR", "K_PERSIST", "K_TIMEOUT", "K_PASSWD", "K_PROG", "K_PPP",
  "K_SPEED", "K_IFCFG", "K_FWALL", "K_ROUTE", "K_DEVICE", "K_MULTI",
  "K_SRCADDR", "K_IFACE", "K_ADDR", "K_TYPE", "K_PROT", "K_COMPRESS",
  "K_ENCRYPT", "K_KALIVE", "K_STAT", "K_UP", "K_DOWN", "K_SYSLOG",
  "K_IPROUTE", "K_HOST", "K_ERROR", "WORD", "PATH", "STRING", "NUM",
  "DNUM", "'\\n'", "'{'", "'}'", "$accept", "config", "statement", "@1",
  "@2", "options", "option", "bindaddr_option", "syslog_opt",
  "host_options", "host_option", "@3", "@4", "@5", "@6", "compress",
  "keepalive", "srcaddr_options", "srcaddr_option", "command_options",
  "command_option", "@7", "prog_options", "prog_option", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    10,   123,
     125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    41,    42,    42,    43,    43,    44,    43,    45,    43,
      43,    46,    46,    47,    47,    47,    47,    47,    47,    47,
      47,    47,    47,    47,    47,    47,    48,    48,    48,    48,
      49,    49,    49,    50,    50,    51,    51,    51,    51,    51,
      51,    51,    52,    51,    51,    53,    51,    51,    51,    51,
      51,    51,    54,    51,    55,    51,    51,    56,    56,    56,
      57,    57,    57,    58,    58,    58,    59,    59,    59,    59,
      59,    60,    60,    60,    61,    62,    61,    61,    61,    61,
      61,    61,    61,    63,    63,    64,    64,    64
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     4,     0,     5,     0,     5,
       1,     1,     2,     1,     2,     4,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     2,     1,     2,     2,     2,     2,
       2,     2,     0,     3,     2,     0,     3,     2,     2,     2,
       2,     4,     0,     5,     0,     5,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     2,     2,     2,     2,     2,
       1,     0,     1,     2,     1,     0,     3,     2,     2,     2,
       2,     2,     1,     1,     2,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,     0,     6,     8,    10,     4,     3,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    25,    13,     0,    11,     0,     0,    14,
       0,    18,    19,    20,    22,    21,    16,    17,    32,    31,
      30,    24,    23,     5,    12,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    42,     0,    45,     0,    52,    54,
      56,    35,     0,    33,     0,     0,     0,    29,     0,    48,
      39,    36,    40,    41,    37,    38,    63,    49,    50,     0,
      44,     0,    47,     0,     0,     7,    34,     9,    27,    28,
      26,    15,     0,     0,     0,    70,     0,    64,    59,    57,
      58,    43,    62,    60,    61,    46,    71,    71,    69,    67,
      68,    66,    51,    65,    75,     0,     0,     0,     0,     0,
      82,    74,     0,    72,     0,     0,    77,    78,    80,    79,
      81,    53,    73,    55,    85,    86,    87,    76,    83,    84
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,     8,    10,    11,    25,    26,    68,    41,    62,
      63,    79,    81,    83,    84,   101,   105,    96,    97,   122,
     123,   125,   137,   138
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -74
static const short yypact[] =
{
     -74,     0,   -74,   -13,   -74,   -74,   -74,   -74,   -74,    93,
     -10,    -9,     7,    13,    21,    24,    35,    37,    41,    44,
      49,   -25,    50,   -74,   -74,     4,   -74,   112,   112,   -74,
     -18,   -74,   -74,   -74,   -74,   -74,   -74,   -74,   -74,   -74,
     -74,   -74,   -74,   -74,   -74,    64,    66,    76,   -31,    77,
      81,    74,    82,    90,   -74,    91,   -74,    96,   -74,   -74,
     -74,   -74,    38,   -74,    65,   -11,   108,   -74,   109,   -74,
     -74,   -74,   -74,   -74,   -74,   -74,    48,   -74,   -74,   -16,
     -74,    79,   -74,   114,   118,   -74,   -74,   -74,   -74,   -74,
     -74,   -74,   122,     2,   115,   -74,     8,   -74,   -74,   -74,
     -74,   -74,   -74,   -74,   -74,   -74,   172,   172,   -74,   -74,
     -74,   -74,   -74,   -74,   -74,   124,   125,   126,   128,   130,
     -74,   -74,   132,   -74,   141,    60,   -74,   -74,   -74,   -74,
     -74,   -74,   -74,   -74,   -74,   -74,   -74,    60,   -74,   -74
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
     -74,   -74,   -74,   -74,   -74,   -74,   142,   -74,   -74,   138,
     -23,   -74,   -74,   -74,   -74,   -74,   -74,   -74,    72,    62,
     -73,   -74,   -74,    39
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
       2,    65,    66,     3,     4,    72,    73,    38,    39,    12,
      13,    40,    14,    92,    67,    15,    98,    16,    17,    18,
      99,   100,    88,    19,    89,    20,     9,    93,    94,    27,
      28,     5,     6,    21,    22,   109,    23,   110,     7,    86,
      95,    86,    24,    29,    43,    45,    46,    47,   112,   132,
      48,   132,    30,    92,    49,    50,    51,    31,    32,    52,
      53,    54,    55,    56,    57,    58,    59,    93,    94,    33,
      60,    34,    45,    46,    47,    35,    61,    48,    85,    36,
      95,    49,    50,    51,    42,    37,    52,    53,    54,    55,
      56,    57,    58,    59,   134,   135,   136,    60,    12,    13,
      69,    14,    70,    61,    15,    87,    16,    17,    18,    71,
      74,   102,    19,    76,    20,   103,   104,    75,    77,    45,
      46,    47,    21,    22,    48,    23,    78,    80,    49,    50,
      51,    24,    82,    52,    53,    54,    55,    56,    57,    58,
      59,    90,   114,   115,    60,   116,   117,   118,   111,    91,
      61,   114,   115,   106,   116,   117,   118,   107,   108,   126,
     127,   128,   119,   129,   120,   130,    64,    44,   113,   124,
     121,   119,   131,   120,     0,     0,   139,     0,     0,   121,
       0,   133,   114,   115,     0,   116,   117,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   119,     0,   120,     0,     0,     0,     0,     0,
     121
};

static const short yycheck[] =
{
       0,    19,    20,     3,     4,    36,    37,    32,    33,     5,
       6,    36,     8,     5,    32,    11,    32,    13,    14,    15,
      36,    37,    33,    19,    35,    21,    39,    19,    20,    39,
      39,    31,    32,    29,    30,    33,    32,    35,    38,    62,
      32,    64,    38,    36,    40,     7,     8,     9,    40,   122,
      12,   124,    39,     5,    16,    17,    18,    36,    34,    21,
      22,    23,    24,    25,    26,    27,    28,    19,    20,    34,
      32,    34,     7,     8,     9,    34,    38,    12,    40,    35,
      32,    16,    17,    18,    34,    36,    21,    22,    23,    24,
      25,    26,    27,    28,    34,    35,    36,    32,     5,     6,
      36,     8,    36,    38,    11,    40,    13,    14,    15,    33,
      33,    32,    19,    39,    21,    36,    37,    36,    36,     7,
       8,     9,    29,    30,    12,    32,    36,    36,    16,    17,
      18,    38,    36,    21,    22,    23,    24,    25,    26,    27,
      28,    33,    10,    11,    32,    13,    14,    15,    33,    40,
      38,    10,    11,    39,    13,    14,    15,    39,    36,    35,
      35,    35,    30,    35,    32,    35,    28,    25,    96,   107,
      38,    30,    40,    32,    -1,    -1,   137,    -1,    -1,    38,
      -1,    40,    10,    11,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      38
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    42,     0,     3,     4,    31,    32,    38,    43,    39,
      44,    45,     5,     6,     8,    11,    13,    14,    15,    19,
      21,    29,    30,    32,    38,    46,    47,    39,    39,    36,
      39,    36,    34,    34,    34,    34,    35,    36,    32,    33,
      36,    49,    34,    40,    47,     7,     8,     9,    12,    16,
      17,    18,    21,    22,    23,    24,    25,    26,    27,    28,
      32,    38,    50,    51,    50,    19,    20,    32,    48,    36,
      36,    33,    36,    37,    33,    36,    39,    36,    36,    52,
      36,    53,    36,    54,    55,    40,    51,    40,    33,    35,
      33,    40,     5,    19,    20,    32,    58,    59,    32,    36,
      37,    56,    32,    36,    37,    57,    39,    39,    36,    33,
      35,    33,    40,    59,    10,    11,    13,    14,    15,    30,
      32,    38,    60,    61,    60,    62,    35,    35,    35,    35,
      35,    40,    61,    40,    34,    35,    36,    63,    64,    64
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 93 "cfg_file.y"
    { 
		  parse_host = &default_host; 
                }
    break;

  case 8:
#line 98 "cfg_file.y"
    { 
		  if( !(parse_host = malloc(sizeof(struct vtun_host))) ){
		     yyerror("No memory for the host");
		     YYABORT;
		  }

		  /* Fill new host struct with default values.
		   * MUST dup strings to be able to reread config.
		   */
	  	  memcpy(parse_host, &default_host, sizeof(struct vtun_host));
		  parse_host->host = strdup(yyvsp[0].str);
		  parse_host->passwd = NULL;

		  /* Copy local address */
		  copy_addr(parse_host, &default_host);

		  llist_copy(&default_host.up,&parse_host->up,cp_cmd,NULL);
		  llist_copy(&default_host.down,&parse_host->down,cp_cmd,NULL);

		}
    break;

  case 9:
#line 119 "cfg_file.y"
    {
		  /* Check if session definition is complete */ 
		  if (!parse_host->passwd) {
		  	cfg_error("Ignored incomplete session definition '%s'", parse_host->host);
			free_host(parse_host, NULL);			
			free(parse_host);
		  } else {
		  	/* Add host to the list */
		  	llist_add(&host_list, (void *)parse_host);
		  }
		}
    break;

  case 10:
#line 131 "cfg_file.y"
    {
		  cfg_error("Invalid clause '%s'",yyvsp[0].str);
		  YYABORT;
		}
    break;

  case 14:
#line 144 "cfg_file.y"
    { 
			  if(vtun.bind_addr.port == -1)
			     vtun.bind_addr.port = yyvsp[0].num;
			}
    break;

  case 16:
#line 151 "cfg_file.y"
    { 
			  if(vtun.svr_addr == -1)
			    vtun.svr_addr = strdup(yyvsp[0].str);
			}
    break;

  case 17:
#line 156 "cfg_file.y"
    { 
			  if(vtun.svr_type == -1)
			     vtun.svr_type = yyvsp[0].num;
			}
    break;

  case 18:
#line 161 "cfg_file.y"
    {  
			  if(vtun.timeout == -1)
			     vtun.timeout = yyvsp[0].num; 	
			}
    break;

  case 19:
#line 166 "cfg_file.y"
    {
			  free(vtun.ppp);
			  vtun.ppp = strdup(yyvsp[0].str);
			}
    break;

  case 20:
#line 171 "cfg_file.y"
    {
			  free(vtun.ifcfg);
			  vtun.ifcfg = strdup(yyvsp[0].str);
			}
    break;

  case 21:
#line 176 "cfg_file.y"
    {   
			  free(vtun.route);  
			  vtun.route = strdup(yyvsp[0].str); 	
			}
    break;

  case 22:
#line 181 "cfg_file.y"
    {   
			  free(vtun.fwall);  
			  vtun.fwall = strdup(yyvsp[0].str); 	
			}
    break;

  case 23:
#line 186 "cfg_file.y"
    {   
			  free(vtun.iproute);  
			  vtun.iproute = strdup(yyvsp[0].str); 	
			}
    break;

  case 25:
#line 193 "cfg_file.y"
    {
			  cfg_error("Unknown option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;

  case 26:
#line 200 "cfg_file.y"
    {
			  vtun.bind_addr.name = strdup(yyvsp[0].str);
			  vtun.bind_addr.type = VTUN_ADDR_NAME;
			}
    break;

  case 27:
#line 205 "cfg_file.y"
    {
			  vtun.bind_addr.name = strdup(yyvsp[0].str);
			  vtun.bind_addr.type = VTUN_ADDR_IFACE;
			}
    break;

  case 28:
#line 210 "cfg_file.y"
    {
			  vtun.bind_addr.name = strdup(yyvsp[0].str);
			  vtun.bind_addr.type = VTUN_ADDR_IFACE;
			}
    break;

  case 29:
#line 215 "cfg_file.y"
    {
			  cfg_error("Unknown option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;

  case 30:
#line 222 "cfg_file.y"
    {
                          vtun.syslog = yyvsp[0].num;
  			}
    break;

  case 31:
#line 226 "cfg_file.y"
    {
                          if (parse_syslog(yyvsp[0].str)) {
                            cfg_error("Unknown syslog facility '%s'", yyvsp[0].str);
                            YYABORT;
                          }
                        }
    break;

  case 32:
#line 233 "cfg_file.y"
    {
   			  cfg_error("Unknown syslog option '%s'",yyvsp[0].str);
  			  YYABORT;
			}
    break;

  case 36:
#line 247 "cfg_file.y"
    {
			  free(parse_host->passwd);
			  parse_host->passwd = strdup(yyvsp[0].str);
			}
    break;

  case 37:
#line 252 "cfg_file.y"
    {
			  free(parse_host->dev);
			  parse_host->dev = strdup(yyvsp[0].str);
			}
    break;

  case 38:
#line 257 "cfg_file.y"
    { 
			  parse_host->multi = yyvsp[0].num;
			}
    break;

  case 39:
#line 261 "cfg_file.y"
    { 
			  parse_host->timeout = yyvsp[0].num;
			}
    break;

  case 40:
#line 265 "cfg_file.y"
    { 
			  if( yyvsp[0].num ){ 
			     parse_host->spd_in = parse_host->spd_out = yyvsp[0].num;
			     parse_host->flags |= VTUN_SHAPE;
			  } else 
			     parse_host->flags &= ~VTUN_SHAPE;
			}
    break;

  case 41:
#line 273 "cfg_file.y"
    { 
			  if( yylval.dnum.num1 || yylval.dnum.num2 ){ 
			     parse_host->spd_out = yylval.dnum.num1;
		             parse_host->spd_in = yylval.dnum.num2; 	
			     parse_host->flags |= VTUN_SHAPE;
			  } else 
			     parse_host->flags &= ~VTUN_SHAPE;
			}
    break;

  case 42:
#line 282 "cfg_file.y"
    {
			  parse_host->flags &= ~(VTUN_ZLIB | VTUN_LZO); 
			}
    break;

  case 44:
#line 287 "cfg_file.y"
    {  
			  if( yyvsp[0].num ){
			     parse_host->flags |= VTUN_ENCRYPT;
			     parse_host->cipher = yyvsp[0].num;
			  } else
			     parse_host->flags &= ~VTUN_ENCRYPT;
			}
    break;

  case 45:
#line 295 "cfg_file.y"
    {
			  parse_host->flags &= ~VTUN_KEEP_ALIVE; 
			}
    break;

  case 47:
#line 300 "cfg_file.y"
    {
			  if( yyvsp[0].num )
			     parse_host->flags |= VTUN_STAT;
			  else
			     parse_host->flags &= ~VTUN_STAT;
			}
    break;

  case 48:
#line 307 "cfg_file.y"
    { 
	      		  parse_host->persist = yyvsp[0].num;

			  if(vtun.persist == -1) 
			     vtun.persist = yyvsp[0].num; 	
			}
    break;

  case 49:
#line 314 "cfg_file.y"
    {  
			  parse_host->flags &= ~VTUN_TYPE_MASK;
			  parse_host->flags |= yyvsp[0].num;
			}
    break;

  case 50:
#line 319 "cfg_file.y"
    {  
			  parse_host->flags &= ~VTUN_PROT_MASK;
			  parse_host->flags |= yyvsp[0].num;
			}
    break;

  case 52:
#line 326 "cfg_file.y"
    { 
			  parse_cmds = &parse_host->up; 
   			  llist_free(parse_cmds, free_cmd, NULL);   
			}
    break;

  case 54:
#line 331 "cfg_file.y"
    { 
			  parse_cmds = &parse_host->down; 
   			  llist_free(parse_cmds, free_cmd, NULL);   
			}
    break;

  case 56:
#line 336 "cfg_file.y"
    {
			  cfg_error("Unknown option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;

  case 57:
#line 343 "cfg_file.y"
    { 
			  if( yyvsp[0].num ){  
      			     parse_host->flags |= VTUN_ZLIB; 
			     parse_host->zlevel = yyvsp[0].num;
			  }
			}
    break;

  case 58:
#line 350 "cfg_file.y"
    {
			  parse_host->flags |= yylval.dnum.num1;
		          parse_host->zlevel = yylval.dnum.num2;
  			}
    break;

  case 59:
#line 355 "cfg_file.y"
    {
			  cfg_error("Unknown compression '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;

  case 60:
#line 362 "cfg_file.y"
    { 
			  if( yyvsp[0].num )
			     parse_host->flags |= VTUN_KEEP_ALIVE;
			}
    break;

  case 61:
#line 367 "cfg_file.y"
    {
			  if( yylval.dnum.num1 ){
			     parse_host->flags |= VTUN_KEEP_ALIVE;
			     parse_host->ka_interval = yylval.dnum.num1;
		             parse_host->ka_failure  = yylval.dnum.num2;
			  }
  			}
    break;

  case 62:
#line 375 "cfg_file.y"
    {
			  cfg_error("Unknown keepalive option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;

  case 66:
#line 387 "cfg_file.y"
    {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup(yyvsp[0].str);
			  parse_host->src_addr.type = VTUN_ADDR_NAME;
			}
    break;

  case 67:
#line 393 "cfg_file.y"
    {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup(yyvsp[0].str);
			  parse_host->src_addr.type = VTUN_ADDR_IFACE;
			}
    break;

  case 68:
#line 399 "cfg_file.y"
    {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup(yyvsp[0].str);
			  parse_host->src_addr.type = VTUN_ADDR_IFACE;
			}
    break;

  case 69:
#line 405 "cfg_file.y"
    {
			  parse_host->src_addr.port = yyvsp[0].num;
			}
    break;

  case 70:
#line 409 "cfg_file.y"
    {
			  cfg_error("Unknown option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;

  case 75:
#line 421 "cfg_file.y"
    {
			  memset(&parse_cmd, 0, sizeof(struct vtun_cmd));
			}
    break;

  case 76:
#line 424 "cfg_file.y"
    {
			  add_cmd(parse_cmds, parse_cmd.prog, 
				  parse_cmd.args, parse_cmd.flags);
			}
    break;

  case 77:
#line 429 "cfg_file.y"
    {   
			  add_cmd(parse_cmds, strdup(vtun.ppp), strdup(yyvsp[0].str), 
					VTUN_CMD_DELAY);
			}
    break;

  case 78:
#line 434 "cfg_file.y"
    {   
			  add_cmd(parse_cmds, strdup(vtun.ifcfg),strdup(yyvsp[0].str),
					VTUN_CMD_WAIT);
			}
    break;

  case 79:
#line 439 "cfg_file.y"
    {   
			  add_cmd(parse_cmds, strdup(vtun.route),strdup(yyvsp[0].str),
					VTUN_CMD_WAIT);
			}
    break;

  case 80:
#line 444 "cfg_file.y"
    {   
			  add_cmd(parse_cmds, strdup(vtun.fwall),strdup(yyvsp[0].str),
					VTUN_CMD_WAIT);
			}
    break;

  case 81:
#line 449 "cfg_file.y"
    {   
			  add_cmd(parse_cmds, strdup(vtun.iproute),strdup(yyvsp[0].str),
					VTUN_CMD_WAIT);
			}
    break;

  case 82:
#line 454 "cfg_file.y"
    {
			  cfg_error("Unknown cmd '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;

  case 85:
#line 466 "cfg_file.y"
    {
			  parse_cmd.prog = strdup(yyvsp[0].str);
			}
    break;

  case 86:
#line 470 "cfg_file.y"
    {
			  parse_cmd.args = strdup(yyvsp[0].str);
			}
    break;

  case 87:
#line 474 "cfg_file.y"
    {
			  parse_cmd.flags = yyvsp[0].num;
			}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 1767 "cfg_file.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 478 "cfg_file.y"


int yyerror(char *s) 
{
   vtun_syslog(LOG_ERR, "%s line %d\n", s, lineno);
   return 0;
}

int cfg_error(const char *fmt, ...)
{
   char buf[255];
   va_list ap;

   /* print the argument string */
   va_start(ap, fmt);
   vsnprintf(buf,sizeof(buf),fmt,ap);
   va_end(ap);

   yyerror(buf);
   return 0;
}

int add_cmd(llist *cmds, char *prog, char *args, int flags)
{
   struct vtun_cmd *cmd;
   if( !(cmd = malloc(sizeof(struct vtun_cmd))) ){
      yyerror("No memory for the command");
      return -1;
   }
   memset(cmd, 0, sizeof(struct vtun_cmd)); 		   			

   cmd->prog = prog;
   cmd->args = args;
   cmd->flags = flags;
   llist_add(cmds, cmd);

   return 0;
}		

void *cp_cmd(void *d, void *u)
{
   struct vtun_cmd *cmd = d, *cmd_copy; 

   if( !(cmd_copy = malloc(sizeof(struct vtun_cmd))) ){
      yyerror("No memory to copy the command");
      return NULL;
   }
 
   cmd_copy->prog = strdup(cmd->prog);
   cmd_copy->args = strdup(cmd->args);
   cmd_copy->flags = cmd->flags;
   return cmd_copy;
}

int free_cmd(void *d, void *u)
{
   struct vtun_cmd *cmd = d; 
   free(cmd->prog);
   free(cmd->args);
   free(cmd);
   return 0;
}

void copy_addr(struct vtun_host *to, struct vtun_host *from)
{  
   if( from->src_addr.type ){
      to->src_addr.type = from->src_addr.type;
      to->src_addr.name = strdup(from->src_addr.name);
   }
   to->src_addr.port = from->src_addr.port;
}

void free_addr(struct vtun_host *h)
{  
   if( h->src_addr.type ){
      h->src_addr.type = 0;
      free(h->src_addr.name);
   }
}

int free_host(void *d, void *u)
{
   struct vtun_host *h = d;

   if (u && !strcmp(h->host, u))
      return 1;

   free(h->host);   
   free(h->passwd);   
   
   llist_free(&h->up, free_cmd, NULL);   
   llist_free(&h->down, free_cmd, NULL);

   free_addr(h);
 
   return 0;   
}

/* Find host in the hosts list.
 * NOTE: This function can be called only once since it deallocates hosts list.
 */ 
inline struct vtun_host* find_host(char *host)
{
   return (struct vtun_host *)llist_free(&host_list, free_host, host);
}

inline void free_host_list(void)
{
   llist_free(&host_list, free_host, NULL);
}

static struct {
   char *c_name;
   int  c_val;
} syslog_names[] = {
    { "auth",   LOG_AUTH },
    { "cron",   LOG_CRON },
    { "daemon", LOG_DAEMON },
    { "kern",   LOG_KERN },
    { "lpr",    LOG_LPR },
    { "mail",   LOG_MAIL },
    { "news",   LOG_NEWS },
    { "syslog", LOG_SYSLOG },
    { "user",   LOG_USER },
    { "uucp",   LOG_UUCP },
    { "local0", LOG_LOCAL0 },
    { "local1", LOG_LOCAL1 },
    { "local2", LOG_LOCAL2 },
    { "local3", LOG_LOCAL3 },
    { "local4", LOG_LOCAL4 },
    { "local5", LOG_LOCAL5 },
    { "local6", LOG_LOCAL6 },
    { "local7", LOG_LOCAL7 },
    { NULL, -1 }
};

int parse_syslog(char *facility)
{
   int i;

   for (i=0; syslog_names[i].c_name;i++) {
      if (!strcmp(syslog_names[i].c_name, facility)) {
         vtun.syslog = syslog_names[i].c_val;
         return(0);
      }
   }
}

/* 
 * Read config file. 
 */ 
int read_config(char *file) 
{
   static int cfg_loaded = 0;
   extern FILE *yyin;

   if( cfg_loaded ){
      free_host_list();
      vtun_syslog(LOG_INFO,"Reloading configuration file");
   }	 
   cfg_loaded = 1;

   llist_init(&host_list);

   if( !(yyin = fopen(file,"r")) ){
      vtun_syslog(LOG_ERR,"Can not open %s", file);
      return -1;      
   }

   yyparse();

   free_host(&default_host, NULL);

   fclose(yyin);
  
   return !llist_empty(&host_list);     
}

